/* -*- MaTX -*-
 *
 * tmd00004.h: TMD No. tmd00004 (ľ졼ñΩ)Υإåե
 *
 *  Originally written by KIYOTA Hiromitsu <1999/01/01>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00004.h,v 1.8 1999/05/31 03:22:21 kiyota Exp $
 */

#ifndef _TMD00004_H
#define _TMD00004_H

#ifdef TMD_USER_H
#include TMD_USER_H
#endif /* TMD_USER_H */

#ifdef TMD00004_USER_H
#include TMD00004_USER_H
#endif /* TMD00004_USER_H */

#ifndef TMD00004_MM
#define TMD00004_MM "tmd00004.mm"
#endif /* !TMD00004_MM */

#ifdef TMD_ENABLE_PACKAGE
#ifdef TMD_ANSI
#define tmd00004(var) _tmd00004_ ## var
#else /* ! TMD_ANSI */
#define tmd00004(var) _tmd00004_/**/var
#endif /* TMD_ANSI */
#else /* ! TMD_ENABLE_PACKAGE */
#define tmd00004(var) var
#endif /* TMD_ENABLE_PACKAGE */

#ifndef TMD_EXTERN
#define TMD_EXTERN
#endif /* ! TMD_EXTERN */

// ǥξ֡ϡϤμο
#define TMD00004_DIM_STATE 4
#define TMD00004_DIM_INPUT 1
#define TMD00004_DIM_OUTPUT 2
#define TMD00004_DIM_ALL_IOS (TMD00004_DIM_INPUT+TMD00004_DIM_OUTPUT)

// ǥξ֡ξ֡ϤڤФԤʤޥ(ؿ)
#define chop_state_tmd00004(xx) [xx(1:TMD00004_DIM_STATE)]
#define chop_other_state_tmd00004(xx) [xx(TMD00004_DIM_STATE+1:)]
#define chop_input_tmd00004(uu) [uu(1:TMD00004_DIM_INPUT)]

// ǥʪѥ᡼
TMD_EXTERN Real tmd00004(J), tmd00004(mu), tmd00004(c), tmd00004(l), tmd00004(m);
TMD_EXTERN Real tmd00004(M), tmd00004(a), tmd00004(c1), tmd00004(c2), tmd00004(g);

// ֶɽηޥȥꥯ
TMD_EXTERN Matrix tmd00004(A), tmd00004(B), tmd00004(C);

// ѥåե饰: 1 ǥ; 0 ǥȤ
#ifdef TMD_DISABLE_HALIST
#define TMD00004_DISABLE_HALIST
#endif /* TMD_DISABLE_HALIST */
#ifdef TMD00004_DISABLE_HALIST
TMD_EXTERN Integer tmd00004_flag;
#endif /* TMD00004_DISABLE_HALIST */

// ؿ()
#if !defined(TMD_USER_MM) && !defined(TMD00004_USER_MM) || !defined(TMD_DIVIDED_COMPILE) && !defined(TMD00004_DIVIDED_COMPILE)
#include TMD00004_MM
#else /* !(!TMD_USER_MM && !TMD00004_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00004_DIVIDED_COMPILE) */
void init_tmd00004(/* linear_flag, params_flag, */ ...); // require TMD00004_MM;
Matrix diff_tmd00004(/* t, x, u */); // require TMD00004_MM;
Matrix output_tmd00004(/* t, x, u */); // require TMD00004_MM;
#endif /* !TMD_USER_MM && !TMD00004_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00004_DIVIDED_COMPILE */

#undef TMD_EXTERN
#endif /* ! _TMD00004_H */
